<?php

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

/**
 * The file that defines the core plugin class
 *
 * A class definition that includes attributes and functions used across both the
 * public-facing side of the site and the admin area.
 *
 * @link       http://example.com
 * @since      1.0.0
 *
 * @package    Mds_Product_Bulk_Editor_For_Woocommerce
 * @subpackage Mds_Product_Bulk_Editor_For_Woocommerce/includes
 */

/**
 * The core plugin class.
 *
 * This is used to define internationalization, admin-specific hooks, and
 * public-facing site hooks.
 *
 * Also maintains the unique identifier of this plugin as well as the current
 * version of the plugin.
 *
 * @since      1.0.0
 * @package    Mds_Product_Bulk_Editor_For_Woocommerce
 * @subpackage Mds_Product_Bulk_Editor_For_Woocommerce/includes
 * @author     Your Name <email@example.com>
 */
class MDSPBE {

	/**
	 * The loader that's responsible for maintaining and registering all hooks that power
	 * the plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      MDSPBE_Loader    $loader    Maintains and registers all hooks for the plugin.
	 */
	protected $loader;

	/**
	 * The unique identifier of this plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      string    $mds_product_bulk_editor    The string used to uniquely identify this plugin.
	 */
	protected $mds_product_bulk_editor;

	/**
	 * The current version of the plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      string    $version    The current version of the plugin.
	 */
	protected $version;

	/**
	 * Define the core functionality of the plugin.
	 *
	 * Set the plugin name and the plugin version that can be used throughout the plugin.
	 * Load the dependencies, define the locale, and set the hooks for the admin area and
	 * the public-facing side of the site.
	 *
	 * @since    1.0.0
	 */
	public function __construct() {
		if ( defined( 'MDSPBE_VERSION' ) ) {
			$this->version = MDSPBE_VERSION;
		} else {
			$this->version = '1.0.0';
		}
		$this->mds_product_bulk_editor =  'mds-product-bulk-editor-for-woocommerce';

		$this->load_dependencies();
		$this->define_admin_hooks();

	}

	/**
	 * Load the required dependencies for this plugin.
	 *
	 * Include the following files that make up the plugin:
	 *
	 * - MDSPBE_Loader. Orchestrates the hooks of the plugin.
	 * - MDSPBE_i18n. Defines internationalization functionality.
	 * - MDSPBE_Admin. Defines all hooks for the admin area.
	 * - MDSPBE_Public. Defines all hooks for the public side of the site.
	 *
	 * Create an instance of the loader which will be used to register the hooks
	 * with WordPress.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function load_dependencies() {

		/**
		 * The class responsible for orchestrating the actions and filters of the
		 * core plugin.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-mds-product-bulk-editor-for-woocommerce-loader.php';

		/**
		 * The class responsible for defining REST API functionality
		 * of the plugin.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-mds-product-bulk-editor-for-woocommerce-rest-api.php';

		/**
		 * The class responsible for defining form handlers functionality
		 * of the plugin.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-mds-product-bulk-editor-for-woocommerce-handlers.php';

		/**
		 * The class responsible for defining all actions that occur in the admin area.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'admin/class-mds-product-bulk-editor-for-woocommerce-admin.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/functions.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/product-attributes.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/helper.php';

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'languages/js-strings.php';

		// ATUM stock manager integration
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/atum-stock-manager/loader.php';

		$this->loader = new MDSPBE_Loader();

	}

	/**
	 * Register all of the hooks related to the admin area functionality
	 * of the plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function define_admin_hooks() {

		$plugin_admin = new MDSPBE_Admin( $this->get_mds_product_bulk_editor(), $this->get_version() );

		$this->loader->add_action( 'admin_enqueue_scripts', $plugin_admin, 'enqueue_styles' );
		$this->loader->add_action( 'admin_enqueue_scripts', $plugin_admin, 'enqueue_scripts' );

		$this->loader->add_action( 'admin_menu', $plugin_admin, 'add_options_menu' );
	}

	/**
	 * Run the loader to execute all of the hooks with WordPress.
	 *
	 * @since    1.0.0
	 */
	public function run() {
		$this->loader->run();
	}

	/**
	 * The name of the plugin used to uniquely identify it within the context of
	 * WordPress and to define internationalization functionality.
	 *
	 * @since     1.0.0
	 * @return    string    The name of the plugin.
	 */
	public function get_mds_product_bulk_editor() {
		return $this->mds_product_bulk_editor;
	}

	/**
	 * The reference to the class that orchestrates the hooks with the plugin.
	 *
	 * @since     1.0.0
	 * @return    MDSPBE_Loader    Orchestrates the hooks of the plugin.
	 */
	public function get_loader() {
		return $this->loader;
	}

	/**
	 * Retrieve the version number of the plugin.
	 *
	 * @since     1.0.0
	 * @return    string    The version number of the plugin.
	 */
	public function get_version() {
		return $this->version;
	}

}
